#include "ChipType.h"


int ChipType::CHIPTYPE_89S51;
int ChipType::CHIPTYPE_89S52;
int ChipType::CHIPTYPE_89S8253;


ChipType::ChipType()
{
    Init();
}


void ChipType::Init()
{

    manufactureCode = 0;
    chipNameCode = 0;
    nameCode = 0;
    clockType = 0;
    type = 0;
    lockbits = 0;
    CHIPTYPE_89S51 = 0x51 ;
    CHIPTYPE_89S52 = 0x52;
    CHIPTYPE_89S8253 = 0x73;




}


wxString ChipType::getName()
{


    if(chipNameCode == 0x52)
    {
        printf("Chip name: 89S52\n");
        return _T("89S52");

    }
    else if(chipNameCode == 0x73)
    {
        printf("Chip name: 89S8253\n");
        return _T("89S8253");

    }
    else if(chipNameCode == 0x51)
    {
        printf("Chip name: 89S51\n");
        return _T("89S51");

    }
    else
    {
        return _T("Unknown");
    }




}



wxString ChipType::getManufactured()
{


    if(manufactureCode == 0x1e)
    {
        printf("Manufactured by Atmel\n");
        return _T("Atmel");
    }
    else
    {
        printf("Manufactured: 0x%x\n",manufactureCode );
        return _T("Unknown");

    }
}



int getBit(int number, int position)
{
    unsigned int bitmask = 1 << position;
    return (number & bitmask) ? 1 : 0;
}




void log( wxString logline)
{


    wxString fileName = _T("log.txt");

    wxDateTime datetime = wxDateTime::Today();
    wxString dateString = datetime.Format(_T("%d-%m-%Y %H:%M:%S"));

    logline = dateString + _T(" >>> ") +logline;

    wxTextFile file(fileName);
    wxMBConv& conv = wxConvISO8859_1;
    wxTextFileType typeNew = wxTextFileType_Dos;

    if(! file.Exists())
    {
        file.Create();

    }

    file.Open( conv);

    file.AddLine(logline);
    file.Write(typeNew,conv);
    file.Close();


}






wxString ChipType::getLockMode()
{


    int b1 = getBit(lockbits,0);
    int b2 = getBit(lockbits,1);
    int b3 = getBit(lockbits,2);



    if(chipNameCode == CHIPTYPE_89S51 || chipNameCode == CHIPTYPE_89S52 )
    {
        if(!b1 &&  !b2 && !b3)
            return _T("Mode 1, no lock protection");
        if(b1 &&  !b2 && !b3)
            return _T("Mode 2");
        if(b1 &&  b2 && !b3)
            return _T("Mode 3");
        if(b1 &&  b2 && b3)
            return _T("Mode 4");
    }


    if(chipNameCode ==  CHIPTYPE_89S8253 )
    {
        if(b1 &&  b2 && b3)
            return _T("Mode 1, no lock protection");
        if(!b1 &&  b2  && b3)
            return _T("Mode 2");
        if(!b1 &&  !b2 && b3)
            return _T("Mode 3");
        if(!b1 &&  !b2 && !b3)
            return _T("Mode 4");
    }

    return    _T("Unknown");



}









