#include "IspMain.h"
#include "IspProgrammer.h"

const long IspFrame::ID_buttonDetect = wxNewId();
const long IspFrame::ID_buttonPortDetect = wxNewId();
const long IspFrame::ID_buttonCloseWindow = wxNewId();
const long IspFrame::ID_buttonStopJob = wxNewId();
const long IspFrame::ID_comboBoxPort = wxNewId();
const long IspFrame::ID_Gauge = wxNewId();
const long IspFrame::ID_TextWindow= wxNewId();




const long idMenuLoadFile = wxNewId();
const long idMenuShowLoadedFile = wxNewId();
const long idMenuShowLogFile = wxNewId();

const long idMenuQuit = wxNewId();



const long idMenuVerifyFlash = wxNewId();
const long idMenuWriteFlash = wxNewId();

const long idMenuEraseFlash = wxNewId();
const long idMenuDumpFlash = wxNewId();
const long idMenuShowFlash = wxNewId();

const long idMenuLockMode2 = wxNewId();
const long idMenuLockMode3 = wxNewId();
const long idMenuLockMode4 = wxNewId();



const long idMenuAbout = wxNewId();



wxArrayString comboBoxPortChoices;
ChipType* chipType = new ChipType();

int fd = 0;
int interface = 0;




unsigned long WRITE_NO_LOCK_BITS =    0xACE70000L;
unsigned long WRITE_LB1_LOCK_BITS =   0xACE60000L;
unsigned long WRITE_LB2_LOCK_BITS =   0xACE50000L;
unsigned long WRITE_LB3_LOCK_BITS =   0xACE30000L;




BEGIN_EVENT_TABLE(IspFrame,wxFrame)
    //(*EventTable(IspFrame)
    //*)
    EVT_MENU(idMenuQuit, IspFrame::OnMenuQuit)
    EVT_MENU(idMenuLoadFile, IspFrame::OnMenuLoadFile)
    EVT_MENU(idMenuShowLogFile, IspFrame::OnMenuShowLogFile)
    EVT_MENU(idMenuShowLoadedFile, IspFrame::OnMenuShowLoadedFile)


    EVT_MENU(idMenuVerifyFlash, IspFrame::OnMenuVerifyFlash)
    EVT_MENU(idMenuWriteFlash, IspFrame::OnMenuWriteFlash)


    EVT_MENU(idMenuDumpFlash, IspFrame::OnMenuDumpFlash)
    EVT_MENU(idMenuShowFlash, IspFrame::OnMenuShowFlash)
    EVT_MENU(idMenuEraseFlash, IspFrame::OnMenuEraseFlash)


    EVT_MENU(idMenuLockMode2, IspFrame::OnMenuLockMode2)
    EVT_MENU(idMenuLockMode3, IspFrame::OnMenuLockMode3)
    EVT_MENU(idMenuLockMode4, IspFrame::OnMenuLockMode4)

    EVT_MENU(idMenuAbout, IspFrame::OnMenuAbout)
    EVT_COMBOBOX(ID_comboBoxPort,IspFrame::OnComboBoxPortChange)






END_EVENT_TABLE()


wxMenu* fileMenu ;
wxMenu* flashMenu ;
wxMenu* lockMenu ;
wxMenu* helpMenu ;


IspProgrammer ip ;




IspFrame::IspFrame(wxWindow* parent,wxWindowID id)
{





    //(*Initialize(IspFrame)
    Create(parent,id,wxEmptyString,wxDefaultPosition,wxSize(900,400),wxDEFAULT_FRAME_STYLE,_T("id"));


    wxMenuBar* mbar = new wxMenuBar();


    fileMenu = new wxMenu(_T(""));
    flashMenu = new wxMenu(_T(""));
    lockMenu = new wxMenu(_T(""));
    helpMenu = new wxMenu(_T(""));


    fileMenu->Append(idMenuLoadFile, _T("&Load"), _T("Load file"));
    fileMenu->Append(idMenuShowLogFile, _T("&Show log file"), _T("Show log file"));
    fileMenu->Append(idMenuShowLoadedFile, _T("&Show loaded file"), _T("Show loaded file"));
    fileMenu->Append(idMenuQuit, _T("&Quit"), _T("Quit the application"));



    flashMenu->Append(idMenuVerifyFlash, _T("&Verify"), _T("Verify"));
    flashMenu->Append(idMenuWriteFlash, _T("&Write"), _T("Write"));


    flashMenu->Append(idMenuDumpFlash, _T("&Dump to file"), _T("Dump"));
    flashMenu->Append(idMenuShowFlash, _T("&Show"), _T("Show"));
    flashMenu->Append(idMenuEraseFlash, _T("&Erase"), _T("Erase"));


    lockMenu->Append(idMenuLockMode2, _T("&Mode2"), _T("Mode 2"));
    lockMenu->Append(idMenuLockMode3, _T("&Mode3"), _T("Mode 3"));
    lockMenu->Append(idMenuLockMode4, _T("&Mode4"), _T("Mode 4"));


    helpMenu->Append(idMenuAbout, _T("&About"), _T("About"));

    mbar->Append(fileMenu, _T("&File"));
    mbar->Append(flashMenu, _T("&Flash"));
    mbar->Append(lockMenu, _T("&Lock"));
    mbar->Append(helpMenu, _T("&Help"));



    SetMenuBar(mbar);


    comboBoxPort =   new wxComboBox(this, ID_comboBoxPort, _T("Port"),  wxPoint(10,10), wxSize( 150, 25 ), comboBoxPortChoices,  0);
    buttonPortDetect = new wxButton(this,ID_buttonPortDetect,_T("Detect USB ports"),wxPoint(160,10),wxSize( 130, 25 ));



    manufactureText = new wxStaticText(this, wxID_ANY, wxT("Manufacture : "), wxPoint(10,70), wxDefaultSize, 0);
    manufactureText->SetFont(wxFont(20, 74, 90, 90, false, wxT("Arial")));

    chipNameText = new wxStaticText(   this, wxID_ANY, wxT("Chipname    : "), wxPoint(10,100), wxDefaultSize, 0);
    chipNameText->SetFont(wxFont(20, 74, 90, 90, false, wxT("Arial")));



    lockBitsText = new wxStaticText(   this, wxID_ANY, wxT("Lockmode   : "), wxPoint(10,130), wxDefaultSize, 0);
    lockBitsText->SetFont(wxFont(20, 74, 90, 90, false, wxT("Arial")));

    loadedFileNameText = new wxStaticText(   this, wxID_ANY, wxT("Loaded file   : "), wxPoint(10,180), wxDefaultSize, 0);
    loadedFileNameText->SetFont(wxFont(15, 74, 90, 90, false, wxT("Arial")));



    textWindow = new wxTextCtrl(this  , ID_TextWindow, _T(""),  wxPoint(550,10) ,wxSize( 300, 280 ),wxTE_MULTILINE);

    buttonCloseWindow = new wxButton(this,ID_buttonCloseWindow,_T("X"),wxPoint(860,10),wxSize( 20, 20 ));




    buttonDetect = new wxButton(this,ID_buttonDetect,_T("Detect chip"),wxPoint(10,250),wxDefaultSize);



    progressText = new wxStaticText(   this, wxID_ANY, wxT("Progress"), wxPoint(350,265), wxSize( 900, 25 ), 0);
    progressText->SetFont(wxFont(20, 74, 90, 90, false, wxT("Arial")));



    int range;
    processBar = new wxGauge(this, ID_Gauge , range, wxPoint(10,300),  wxSize( 850 ,25 ),  wxGA_HORIZONTAL, wxDefaultValidator);

    buttonStopJob = new wxButton(this,ID_buttonStopJob,_T("X"),wxPoint(865,300),wxSize( 20, 20 ));


    statusText = new wxStaticText(   this, wxID_ANY, wxT("Status   : "), wxPoint(10,330), wxSize( 900, 25 ), 0);
    statusText->SetFont(wxFont(20, 74, 90, 90, false, wxT("Arial")));





    Connect(ID_buttonDetect,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&IspFrame::OnClickDetect);
    Connect(ID_buttonPortDetect,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&IspFrame::OnClickPortDetect);
    Connect(ID_buttonCloseWindow,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&IspFrame::OnClickCloseWindow);
    Connect(ID_buttonStopJob,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&IspFrame::OnClickStopJob);


    //Connect(ID_wxEVT_COMMAND_TEXT_UPDATED,(wxObjectEventFunction)&IspFrame::OnEditWindowChange);






    setupFromConfig();
    wxString userId =wxGetUserId ();
    log(_T("userId ")+userId);


    loadedFileName = _T("");
    setupShowMenu();


    log(_T("Program started"),TRUE);



    portDetect();


}

IspFrame::~IspFrame()
{
}






void IspFrame::OnMenuAbout(wxCommandEvent& event)
{
    int answer = wxMessageBox(_T("Programmer for \n89S51,89S52 and 89S8253 \nhttps://github.com/srikantpatnaik/8051-Programmer"), _T("About"),   wxOK , this);

}






void IspFrame::setupShowMenu()
{

    buttonDetect->Enable(TRUE);
    buttonCloseWindow->Show(FALSE);
    textWindow->Show(FALSE);
    buttonStopJob->Show(FALSE);

    if(processBar->GetValue() > 0){
       buttonStopJob->Show(TRUE);
    }


    fileMenu->Enable(idMenuShowLoadedFile,false);
    flashMenu->Enable(idMenuWriteFlash,false);
    flashMenu->Enable(idMenuEraseFlash,false);
    flashMenu->Enable(idMenuDumpFlash,false);
    flashMenu->Enable(idMenuVerifyFlash,false);
    lockMenu->Enable(idMenuLockMode2,false);
    lockMenu->Enable(idMenuLockMode3,false);
    lockMenu->Enable(idMenuLockMode4,false);


    if( loadedFileName.Len() > 0 )
    {
        fileMenu->Enable(idMenuShowLoadedFile,true);
    }


    if(chipType->chipNameCode > 0)
    {
        flashMenu->Enable(idMenuEraseFlash,true);
        flashMenu->Enable(idMenuDumpFlash,true);
        lockMenu->Enable(idMenuLockMode2,true);
        lockMenu->Enable(idMenuLockMode3,true);
        lockMenu->Enable(idMenuLockMode4,true);
    }



    if( (loadedFileName.Len() > 0 ) && (chipType->chipNameCode > 0  ) )
    {
        flashMenu->Enable(idMenuWriteFlash,true);
        flashMenu->Enable(idMenuVerifyFlash,true);
    }



    if(fd == -1)
    {
        buttonDetect->Enable(FALSE);
    }



}


void IspFrame::OnMenuQuit(wxCommandEvent& event)
{
    Close();

}





void IspFrame::showFile(wxString fileName){

 FILE *bin;
    unsigned int data;
    unsigned  int address_flash =0;



    wxFileName  fi =  wxFileName(fileName);
    wxULongLong size = fi.GetSize() ;
    int max = size.ToULong();


    char cFileName[100];
    strcpy(cFileName,(const char*) fileName.mb_str(wxConvUTF8));





    if((bin=fopen(cFileName,"r"))==NULL)
    {

        log(_T("File not found: ")+fileName);

        return ;
    }


    wxDialog   textDialog(this , -1, _T("Dialog"),  wxDefaultPosition,  wxSize( 600, 500 ));
    wxTextCtrl* textWindow = new wxTextCtrl(&textDialog  , -1, _T(""), wxDefaultPosition ,wxSize( 600, 500 ),wxTE_MULTILINE);




    int line =0;
    textWindow->AppendText(_T("\n0x00  :"));;
    while((data=fgetc(bin))!=EOF)
    {
        wxString stringnumber = wxString::Format(wxT("%02X ") ,data);
        textWindow->AppendText(stringnumber);
        address_flash++;
        line++;
        if(line >= 10)
        {
            line =0;
            wxString stringnumber = wxString::Format(wxT("\n0x%02x  : ") ,address_flash);
            textWindow->AppendText(stringnumber);;

        }

    }


    textDialog.ShowModal();

}


void IspFrame::OnMenuShowLoadedFile(wxCommandEvent& event)
{

   showFile(loadedFileName);

}

void IspFrame::OnMenuShowLogFile(wxCommandEvent& event)
{



    FILE *bin;
    unsigned int data;


    if((bin=fopen("log.txt","r"))==NULL)
    {

        log(_T("File not found: log.txt "));
        return ;
    }


    wxDialog   textDialog(this , -1, _T("Dialog"),  wxDefaultPosition,  wxSize( 600, 500 ));
    wxTextCtrl* textWindow = new wxTextCtrl(&textDialog  , -1, _T(""), wxDefaultPosition ,wxSize( 600, 500 ),wxTE_MULTILINE);


    textWindow->AppendText(_T("\n0x00  :"));;
    while((data=fgetc(bin))!=EOF)
    {
        wxString stringnumber = wxString::Format(wxT("%c") ,data);
        textWindow->AppendText(stringnumber);

    }


    textDialog.ShowModal();



}


void IspFrame::OnMenuLoadFile(wxCommandEvent& event)
{


    wxFileDialog* dialog = new  wxFileDialog(NULL, _T("filename to load"), _T("Load file"), _T(""), _T("HEX and BIN files (*.hex;*.bin)|*.hex;*.bin|ALL files (*.*)|*"), wxOPEN | wxMULTIPLE ,  wxDefaultPosition);


    if (dialog->ShowModal() == wxID_CANCEL)
        return;     // the user changed idea...




    wxString filePath =   dialog->GetPath();

    loadedFileName = filePath;

    log(_T("FilePath ")+filePath);




    if(filePath.EndsWith(_T(".hex")))
    {
        workerThread = new IspThread();
        workerThread->setProcessBar(processBar);
        workerThread->setJob(IspThread::threadJob_LoadFile);

        workerThread->setStatusText(statusText);
        workerThread->setFileName(filePath);

        workerThread->Create(wxTHREAD_DETACHED);
        workerThread->Run();
        log(_T("Started"));
    }

    loadedFileNameText->SetLabel(_T("Loaded file   : ")+filePath);


    setupShowMenu();







}

void IspFrame::OnMenuVerifyFlash(wxCommandEvent& event)
{
   buttonStopJob->Show(TRUE);

    wxString binFileName = loadedFileName.Left(loadedFileName.length()-4) +_T(".bin") ;
    log(_T("binFileName: ")+binFileName);
    workerThread = new IspThread();
    workerThread->setProcessBar(processBar);
    workerThread->setJob(IspThread::threadJob_Verify);
    workerThread->setComDevice(comboBoxPort->GetValue() );
    workerThread->setSerialDescripter(fd);
    workerThread->setStatusText(statusText);
    workerThread->setFileName(binFileName);
    workerThread->Create(wxTHREAD_DETACHED);
    workerThread->Run();
    log(_T("Started"));


}
void IspFrame::OnMenuWriteFlash(wxCommandEvent& event)
{

   buttonStopJob->Show(TRUE);


   buttonCloseWindow->Show(TRUE);
   textWindow->Show(TRUE);


    wxString binFileName = loadedFileName.Left(loadedFileName.length()-4) +_T(".bin") ;


    /*
        ip.setInterface(0);
        ip.setupComm();
        processBar->SetValue(20);
        ip.programFile(binFileName,processBar);
         return;
    */

    workerThread = new IspThread();
    workerThread->setProcessBar(processBar);
    workerThread->setJob(IspThread::threadJob_Program);
    workerThread->setInterface(interface);
    workerThread->setComDevice(comboBoxPort->GetValue() );
    workerThread->setSerialDescripter(fd);
    workerThread->setStatusText(statusText);
    workerThread->setFileName(binFileName);
    workerThread->setRepportWindow(textWindow);
    workerThread->Create(wxTHREAD_DETACHED);
    workerThread->Run();
    log(_T("Started"));





}



void IspFrame::OnMenuDumpFlash(wxCommandEvent& event)
{

   buttonStopJob->Show(TRUE);

   buttonCloseWindow->Show(TRUE);
   textWindow->Show(TRUE);


    wxFileDialog* dialog = new  wxFileDialog(NULL, _T("Filename dumpfile"), _T("TDCPLAY_download"), _T(""), _T("All files (*.*)|*"), wxFD_SAVE|wxFD_OVERWRITE_PROMPT ,  wxDefaultPosition);
//  dialog->ShowModal();


    if (dialog->ShowModal() == wxID_CANCEL)
        return;     // the user changed idea...




    wxString fileName =   dialog->GetFilename();
    log(_T("FileName ")+fileName);


    wxString filePath =   dialog->GetPath();
    log(_T("FilePath ")+filePath);





    workerThread = new IspThread();
    workerThread->setProcessBar(processBar);
    workerThread->setJob(IspThread::threadJob_Dump);
    workerThread->setComDevice(comboBoxPort->GetValue() );
    workerThread->setSerialDescripter(fd);
    workerThread->setFileName(filePath);
    workerThread->setStatusText(statusText);
    workerThread->setRepportWindow(textWindow);
    workerThread->Create(wxTHREAD_DETACHED);
    workerThread->Run();
    log(_T("Started"));



}

void IspFrame::OnMenuShowFlash(wxCommandEvent& event)
{

    buttonStopJob->Show(TRUE);


   buttonCloseWindow->Show(TRUE);
   textWindow->Show(TRUE);



    wxString filePath =   _T("tempDump");
    log(_T("FileName ")+filePath);











    workerThread = new IspThread();
    workerThread->setProcessBar(processBar);
    workerThread->setJob(IspThread::threadJob_Dump);
    workerThread->setComDevice(comboBoxPort->GetValue() );
    workerThread->setSerialDescripter(fd);
    workerThread->setFileName(filePath);
    workerThread->setStatusText(statusText);
    workerThread->setRepportWindow(textWindow);
    workerThread->Create(wxTHREAD_DETACHED );

    workerThread->Run();
    log(_T("Started"));




/*
    statusText->SetLabel(_T("Dumping"));
    ip.setComDevice(comboBoxPort->GetValue() );
    ip.setSerialDescripter(fd);
    wxString result = ip.dumpFlash(filePath ,processBar);
    statusText->SetLabel(result);
*/

//   showFile(_T("tempDump"));


}






void IspFrame::OnMenuEraseFlash(wxCommandEvent& event)
{

    ip.chip_erase();
}





void IspFrame::OnMenuLockMode2(wxCommandEvent& event)
{

    ip.writeLockBits(2,chipType);
    ip.readLockBits(chipType);
    lockBitsText->SetLabel   (_T("Lockmode     : ")+chipType->getLockMode());
}
void IspFrame::OnMenuLockMode3(wxCommandEvent& event)
{

    ip.writeLockBits(3,chipType);
    ip.readLockBits(chipType);
    lockBitsText->SetLabel   (_T("Lockmode     : ")+chipType->getLockMode());
}
void IspFrame::OnMenuLockMode4(wxCommandEvent& event)
{

    ip.writeLockBits(4,chipType);
    ip.readLockBits(chipType);
    lockBitsText->SetLabel   (_T("Lockmode     : ")+chipType->getLockMode());

}





void IspFrame::setupFromConfig()
{



    wxString fileContent = loadFile(_T("config.cfg"));
    wxStringTokenizer tokenizer(fileContent, _T("\n"));

    /*
     while ( tokenizer.HasMoreTokens() )
       {
           wxString token = tokenizer.GetNextToken();
           token.Trim(true);
           token.Trim(false);
           comboBoxInterface->Append(token);
           comboBoxChip->Append(token);
       }
    */

}










void IspFrame::openPort()
{

    ip.setComDevice(comboBoxPort->GetValue() );
    fd =ip.setupComm();

    if(fd > 0)
    {
        statusText->SetLabel(_T("Status   : Port ")+comboBoxPort->GetValue() );
    }
    else
    {
        statusText->SetLabel(_T("Status   : Cound not open port"));
    }

}




void IspFrame::portDetect()
{

    comboBoxPort->Clear();

    //IspProgrammer ip ;
    ip.getUSBPorts(comboBoxPort,_T("ttyU*"));
    comboBoxPort->SetSelection(0);
    openPort();
    setupShowMenu();


}



void IspFrame::OnClickPortDetect(wxCommandEvent& event)
{
    portDetect();
    setupShowMenu();
}

void IspFrame::OnClickCloseWindow(wxCommandEvent& event)
{

     buttonCloseWindow->Show(FALSE);
     textWindow->Show(FALSE);



}


void IspFrame::OnClickStopJob(wxCommandEvent& event)
{

   ip.setJobEnable(FALSE);


}






void IspFrame::OnComboBoxPortChange(wxCommandEvent& event)
{

    log(_T("Port Changed to: ") +comboBoxPort->GetValue());
    openPort();
}






void IspFrame::OnClickDetect(wxCommandEvent& event)
{

    chipType->Init();
    ip.setInterface(interface);
    ip.setComDevice(comboBoxPort->GetValue() );
    ip.setSerialDescripter(fd);

    //fd = ip.setupComm ();

    ip.detectChipType(chipType);
    ip.readLockBits(chipType);

    log(_T("Manufacture : ")+chipType->getManufactured());
    log(_T("Chipname     : ")+chipType->getName());

    printf("lockbits 0x%x\n",chipType->lockbits);
    printf("chipNameCode 0x%x\n",chipType->chipNameCode);
    printf("manufactureCode 0x%x\n",chipType->manufactureCode);


    log(_T("Lockmode     : ")+chipType->getLockMode());


    manufactureText->SetLabel(_T("Manufacture : ")+chipType->getManufactured());
    chipNameText->SetLabel   (_T("Chipname     : ")+chipType->getName());
    lockBitsText->SetLabel   (_T("Lockmode     : ")+chipType->getLockMode());



    if( chipType == NULL || ( chipType->getManufactured().IsSameAs(_T("Unknown"))   && chipType->getName().IsSameAs(_T("Unknown"))) )
    {
        statusText->SetLabel(_T("Status   : Chip NOT detected"));
    }
    else
    {
        statusText->SetLabel(_T("Status   : Chip detected"));

    }


    setupShowMenu();


}



void IspFrame::OnEditWindowChange(wxCommandEvent& event)
{

    //editResult->SetValue( editWindow->GetValue());

}


wxString IspFrame::loadFile(wxString fileName)
{

    wxTextFile file(fileName);

    if(! file.Exists())
    {
        wxString besked = _T("Fil: ")+fileName+_T(" findes ikke.");
        wxMessageDialog* dialog = new  wxMessageDialog(this, besked, _T("Fejl"));
        dialog->ShowModal();
        return _T("");

    }

    file.Close();


    loadedFileName = fileName;

    wxString fileContent;
    wxFileInputStream input(fileName);



#if defined(_WIN32)
    wxTextInputStream text( input ,_T("\n"));
#endif


#if defined(__linux__)
    wxMBConv& conv = wxConvISO8859_1;
    wxTextInputStream text( input ,_T("\n"),conv);
#endif





    while( ! input.Eof())
    {
        wxString line = text.ReadLine();
        fileContent += line;
        fileContent += _T("\n");
    }

    return fileContent;

}





void IspFrame::log( wxString logline,bool clear )
{


    wxString fileName = _T("log.txt");

    wxDateTime datetime = wxDateTime::Today();
    wxString dateString = datetime.Format(_T("%d-%m-%Y %H:%M:%S"));

    logline = dateString + _T(" >>> ") +logline;

    wxTextFile file(fileName);
    wxMBConv& conv = wxConvISO8859_1;
    wxTextFileType typeNew = wxTextFileType_Dos;

    if(! file.Exists())
    {
        file.Create();

    }

    file.Open( conv);
    if(clear)
    {
        file.Clear();
    }

    file.AddLine(logline);
    file.Write(typeNew,conv);
    file.Close();


}




