#ifndef NEWFRAME_H
#define NEWFRAME_H

#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#include <wx/frame.h>
#include <wx/button.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include "IspThread.h"
#include <wx/menu.h>
#include <wx/combobox.h>
#include <wx/tokenzr.h>
#include <wx/textfile.h>
#include <wx/textdlg.h>
#include <wx/msgdlg.h>
#include <wx/wfstream.h>
#include <wx/txtstrm.h>
#include <wx/progdlg.h>

#include "wx/process.h"
#include <wx/wfstream.h>
#include <wx/gauge.h>

#include <wx/filedlg.h>

#include <wx/platinfo.h>
#include <wx/datetime.h>


//*)

class IspFrame: public wxFrame
{
public:



    static const long ID_buttonDetect;
    static const long ID_buttonPortDetect;

    static const long ID_comboBoxPort;
    static const long ID_Gauge;
    static const long ID_TextWindow;
    static const long ID_buttonCloseWindow;
    static const long ID_buttonStopJob;

    wxButton*  buttonDetect;
    wxButton*  buttonPortDetect;
    wxButton*  buttonCloseWindow;
    wxButton*  buttonStopJob;

    wxComboBox* comboBoxPort;
    wxProgressDialog* progress;

    IspThread* workerThread;


    wxStaticText* manufactureText;
    wxStaticText* chipNameText;
    wxStaticText* lockBitsText;
    wxStaticText* statusText;
    wxStaticText* loadedFileNameText;
    wxStaticText* progressText;
     wxTextCtrl* textWindow ;

    wxGauge* processBar;



    wxString loadedFileName;


    IspFrame(wxWindow* parent,wxWindowID id = -1);
    virtual ~IspFrame();
    void OnClickDetect(wxCommandEvent& event);
    void OnClickPortDetect(wxCommandEvent& event);
    void OnClickCloseWindow(wxCommandEvent& event);
    void OnClickStopJob(wxCommandEvent& event);


    void OnEditWindowChange(wxCommandEvent& event);



    void OnMenuQuit(wxCommandEvent& event)		;

    void OnMenuShowLoadedFile(wxCommandEvent& event)		;
    void OnMenuShowLogFile(wxCommandEvent& event)		;

    void OnMenuLoadFile(wxCommandEvent& event)		;


    void OnMenuVerifyFlash(wxCommandEvent& event)		;
    void OnMenuWriteFlash(wxCommandEvent& event)		;





    void OnMenuEraseFlash(wxCommandEvent& event)		;
    void OnMenuDumpFlash(wxCommandEvent& event)		;
    void OnMenuShowFlash(wxCommandEvent& event)		;


    void OnMenuLockMode2(wxCommandEvent& event)		;
    void OnMenuLockMode3(wxCommandEvent& event)		;
    void OnMenuLockMode4(wxCommandEvent& event)		;
    void OnMenuAbout(wxCommandEvent& event)		;
    void OnComboBoxPortChange(wxCommandEvent& event)		;



    void setupShowMenu();
    void openPort();
    void setupFromConfig();
    void portDetect();
    wxString loadFile(wxString fileName);
    void log( wxString logline,bool clear = FALSE);

    void showFile(wxString fileName);


    //(*Identifiers(IspFrame)


    //*)

protected:


    //*)

private:

    DECLARE_EVENT_TABLE()
};

#endif
