#include "IspProgrammer.h"




#define bit_set(value, bit)      ((value) |= (bit))
#define bit_clear(value, bit)    ((value) &= ~(bit))

bool mayRun = TRUE;


unsigned char SCK=0x40;
unsigned char MOSI=0x20;
unsigned char MISO_BITNR=6;
unsigned char MISO_INV=0x00;
unsigned char RESET=0x10;
unsigned char CHIP_ENABLE=0x8;


unsigned long PROGRAM_ENABLE =       0xAC53FF69L;
unsigned long CHIP_ERASE =           0xAC80FFFFL;
unsigned long WRITE_PROGRAM =        0x40000000L;
unsigned long READ_PROGRAM =         0x20000000L;
unsigned long Read_LOCK_BITS =       0x24000000L;


unsigned long const ChipType_1_Read_Signature1_Bytes = 0x28000000L;  //Chip Manufactured:
unsigned long const ChipType_1_Read_Signature2_Bytes = 0x28010000L;   // Chip name
unsigned long const ChipType_1_Read_Signature3_Bytes = 0x28020000L;   // 06 ??

unsigned long const ChipType_2_Read_Signature1_Bytes = 0x28003000L;
unsigned long const ChipType_2_Read_Signature2_Bytes = 0x28003100L;
unsigned long const ChipType_2_Read_Signature3_Bytes = 0x28003200L;

unsigned long Read_Signature1_Bytes = 0;
unsigned long Read_Signature2_Bytes = 0;
unsigned long Read_Signature3_Bytes = 0;





unsigned char clockType =0;
//unsigned char chipType =0;
unsigned char ENABLE;
unsigned char outbyte;

char chipName[] = "Unknown";
char lockbitsDescription[] = "       Unknown            ";
char manufacture[] = "Unknown";



int portAddress =0;
int portStatus;




//Arduino commands
wxString  MOSI_SET = _T("1");
wxString  MOSI_CLEAR = _T("2");
wxString  SCK_SET = _T("3");
wxString  SCK_CLEAR = _T("4");
wxString  RESET_SET = _T("5");
wxString  RESET_CLEAR = _T("6");
wxString  ASK_FOR_DATA = _T("7");
wxString  WRITE = _T("8");


IspProgrammer::IspProgrammer()
{
    comDevice = _T("Not selected");
    mayRun = TRUE;
}



wxString  IspProgrammer::getUSBPorts(wxComboBox* comboBoxInterface,wxString filter)
{


    wxString findString = _T("bash -c \"ls -l /dev/ttyUSB*\" ");
    log(findString);
    wxString result = doShellCommand(findString);
    log(result);



    wxStringTokenizer tokenizer(result, _T("\n"));
    while ( tokenizer.HasMoreTokens() )
    {
        wxString token = tokenizer.GetNextToken();
        if(token.StartsWith(_T("crw")))
        {
            wxStringTokenizer tokenizer2(token, _T("/"));
            wxString port = tokenizer2.GetNextToken();
            port = tokenizer2.GetNextToken();
            port = tokenizer2.GetNextToken();
            log(port);
            token.Trim(true);
            token.Trim(false);
            comboBoxInterface->Append(port);
        }
        else
        {
            comboBoxInterface->Append(_T("None"));
        }


    }


    return result;
}





wxString IspProgrammer::readStream(wxInputStream *input)
{
    wxString result = _T("");

    if (input)
    {
        char buffer[1000+1];
        size_t size=1;
        while (size && !input->Eof())
        {
            input->Read(buffer, sizeof(buffer)-1);
            size=input->LastRead();
            if (size)
            {
                buffer[size]=0;
                result.Append(wxString::FromAscii(buffer));
            }
        }
    }
    return result;
}




wxString  IspProgrammer::doShellCommand(wxString command)
{

    wxString result = _T("");

    wxProcess* sprocess = new wxProcess();
    sprocess->Redirect();
    wxExecute(command , wxEXEC_ASYNC,  sprocess);
    wxInputStream* inputStream = sprocess->GetInputStream();
    wxInputStream* errorInputStream = sprocess->GetErrorStream();
    result = readStream(inputStream);
    result += readStream(errorInputStream);

    return result;
}





struct termios oldtio,newtio;












int IspProgrammer::setupComm()
{



    /* baudrate settings are defined in <asm/termbits.h>, which is
      included by <termios.h> */
#define BAUDRATE B9600
    /* change this definition for the correct port */
#define _POSIX_SOURCE 1 /* POSIX compliant source */
#define FALSE 0
#define TRUE 1



    //  fd = -1;

    log(_T("Opening port ")+comDevice);



    if ( ! comDevice.StartsWith(_T("/dev/")))
    {
        //wxMessageDialog dialog(NULL, _T("Could not open port"), _T("Error"), wxOK | wxCANCEL);
        // dialog.ShowModal();
        return  -1;
    }




    /*
      Open modem device for reading and writing and not as controlling tty
      because we don't want to get killed if linenoise sends CTRL-C.
    */

    fd = open(comDevice.char_str(), O_RDWR | O_NOCTTY| O_NONBLOCK | O_TRUNC);
    //fd = open(comDevice.char_str(), O_RDWR | O_NONBLOCK | O_TRUNC);



    if (fd <0)
    {
        return  -1;
    }

    tcgetattr(fd,&oldtio); /* save current serial port settings */
    bzero(&newtio, sizeof(newtio)); /* clear struct for new port settings */


    newtio.c_cflag = BAUDRATE |  CS8 | CLOCAL | CREAD;

    newtio.c_oflag = 0;

    tcflush(fd, TCIOFLUSH);
    tcsetattr(fd,TCSANOW,&newtio);



    wxString stringnumber = wxString::Format(wxT("%i") ,fd);
    log(_T("Port Opend. fd:  ")+stringnumber);

    return  fd;


}




void IspProgrammer::setupSerialReader()
{

    IspThread*  serialReaderThread ;
    serialReaderThread = new IspThread();
    serialReaderThread->setJob(IspThread::threadJob_SerialRead);
    serialReaderThread->setSerialDescripter(fd);
    //serialReaderThread->setStatusText(statusText);
    serialReaderThread->Create(wxTHREAD_DETACHED);
    serialReaderThread->mayRun = true;
    serialReaderThread->Run();

}







wxString IspProgrammer::verifyFlash(wxString fileName,  wxGauge* progressBar)
{


    bool cont = true;
    FILE *temp;
    int k;

    unsigned  int line = 0;
    unsigned int n =0;
    unsigned long readBack = 0;




    // setupComm();


    prog_enable(0);


    char cFileName[100];
    strcpy(cFileName,(const char*) fileName.mb_str(wxConvUTF8));



    wxFileName  fi =  wxFileName(fileName);
    wxULongLong size = fi.GetSize() ;
    int max = size.ToULong();

    wxMutexGuiEnter();
    progressBar->SetRange(max-1);
    wxMutexGuiLeave();


    if((temp=fopen(cFileName,"r"))!=NULL)
    {

        int result =sendSerialCommand(_T("w"));  // set adresscounter to 0

        while((k=fgetc(temp))!=EOF   and mayRun)
        {

            if(n%10 == 0){
             wxMutexGuiEnter();
             progressBar->SetValue(n);
             wxMutexGuiLeave();
            }

            line++;
            //readBack = clock_command(READ_PROGRAM + n*0x100);
            //unsigned int byte =readBack % 256;

            unsigned long byte = sendSerialCommand(_T("g"));


            if(k != byte)
            {
                wxString stringnumber = wxString::Format(wxT("Verify error location %x  file: %02x    flash: %02x") ,n,k,byte);
                wxMutexGuiEnter();
                log(stringnumber);
                wxMutexGuiLeave();
                fclose(temp);
                return stringnumber;
            }
            n++;
        }
    }
    else
    {
        wxMutexGuiEnter();
        log(_T("File not found"));
        wxMutexGuiLeave();
        return (_T("File not found"));
    }
    fclose(temp);


       if(!mayRun){
        wxMutexGuiEnter();
        repportWindow->AppendText(_T("\n\nCanceled"));
        progressBar->SetValue(0);
        wxMutexGuiLeave();
        mayRun = TRUE;
        return _T("Canceled");
   }



    wxMutexGuiEnter();
    log(_T("Verify OK") ) ;
    progressBar->SetValue(0);
    wxMutexGuiLeave();

    resetPort();

    return _T("Verify OK");


}






wxString  IspProgrammer::dumpFlash(wxString fileName ,wxGauge *progressBar)
{



    int chars =0;
    int n =0;
    int FFCount =0;


    //setupComm();


    prog_enable(0);

    unsigned long readBack = 0;



     wxLongLong startTime = wxGetLocalTimeMillis( )  ;


    FILE *bin;

    if((bin=fopen(fileName.mb_str(),"w"))!=NULL)
    {
        wxMutexGuiEnter();
        log(_T("File opened for write: ")+fileName);
        repportWindow->Clear();
        wxMutexGuiLeave();

    }
    else
    {

        wxMutexGuiEnter();
        log(_T("File could not be created "));
        wxMutexGuiLeave();

    }


       wxMutexGuiEnter();
       repportWindow->AppendText(_T("Counting program size : "));
       wxMutexGuiLeave();



    int count = sendSerialCommand(_T("b"));
    count -= 6;

    wxString stringcount = wxString::Format(wxT("%i bytes.\n") ,count);
    wxMutexGuiEnter();
    repportWindow->AppendText(stringcount);
    progressBar->SetRange(count-1);
    wxMutexGuiLeave();

    wxString buf;



    for (n=0; n < count and mayRun; n++)
    {

        //readBack = clock_command(READ_PROGRAM + n*0x100);
        //int result =readBack % 256;


        unsigned long result = sendSerialCommand(_T("g"));

        fputc(result, bin);
        wxString stringnumber = wxString::Format(wxT("%02X ") ,result);


        if(n%10 == 0){
            wxMutexGuiEnter();
            repportWindow->AppendText(buf);
            progressBar->SetValue(n);
            wxMutexGuiLeave();
            buf = _T("");
        }else{
          buf.Append(stringnumber);
        }


    }

    fclose(bin);

    resetPort();

    wxLongLong endTime = wxGetLocalTimeMillis( )  ;

    wxString stringnumber = wxString::Format(wxT("%i bytes  Dumped. Time elapsed: %i sec. ") ,n,(endTime - startTime)/1000);
    wxMutexGuiEnter();
      progressBar->SetValue(n);
      log(stringnumber+_T("\n"));
      repportWindow->AppendText(buf+_T("\n")+stringnumber);
    wxMutexGuiLeave();




   if(!mayRun){
        wxMutexGuiEnter();
        repportWindow->AppendText(_T("\n\nCanceled"));
        progressBar->SetValue(0);
        wxMutexGuiLeave();
        mayRun = TRUE;
        return _T("Canceled");
   }



    return _T("OK") ;


}





/*

    readFlash

*/

/*

wxString  IspProgrammer::readFlash(wxProgressDialog *progress)
{


    prog_enable(0);

    int chars =0;
    int n =0;
    int FFCount =0;

    unsigned long readBack = 0;
    while(FFCount < 6 and mayRun)
    {
        readBack = clock_command(READ_PROGRAM + n*0x100);
        int lastbyte =readBack % 256;
        if(lastbyte == 0xFF)
        {
            FFCount++;
        }
        else
        {
            FFCount =0;
        }
        wxString stringnumber = wxString::Format(wxT("%02x "), (int)lastbyte);
        log(stringnumber);
        chars++;
        if(chars > 20)
        {
            chars=0;
            log(_T("\n"));
        }
        n++;
    }

    wxString stringnumber = wxString::Format(wxT("Bytes count: %d "), (int)n);
    log(stringnumber);

    resetPort();

       if(!mayRun){
        wxMutexGuiEnter();
        repportWindow->AppendText(_T("\n\nCanceled"));

        wxMutexGuiLeave();
        mayRun = TRUE;
        return _T("Canceled");
   }


    return _T("OK") ;

}


*/
/*

    writeflash

*/


void IspProgrammer::writeflash(unsigned long data,unsigned long address)
{

    wxString datastring = wxString::Format(wxT("d%lud"),data);
    unsigned long result = sendSerialCommand(datastring);

}



/*

    chip_erase

*/



void IspProgrammer::chip_erase(void)
{

    prog_enable(0);
    unsigned long result = sendSerialCommand(_T("e"));
    resetPort();

    /*
    usleep(600000);
    clock_command(PROGRAM_ENABLE);
    usleep(30000);
    printf("Chip Erase done\n");
    resetPort();
    */

}




void IspProgrammer::detectChipType( ChipType* chipType)
{



    log(_T("********** DetectChipType ****************"));

    int readBack =0;
    int lastbyte  =0;
    int result =0;




    setupComm();
    int chiptype = prog_enable(1);
    wxString stringnumber = wxString::Format(wxT("prog_enable: %x"), result);
    log(stringnumber);
    chipType->type =chiptype;

    if(chiptype == 1)
        readBack = clock_command(ChipType_1_Read_Signature1_Bytes);
    if(chiptype == 2)
        readBack = clock_command(ChipType_2_Read_Signature1_Bytes);

    lastbyte =readBack % 256;
    chipType->manufactureCode  = lastbyte;
    log(_T("Chip Manufactured: ")+chipType->getManufactured());

    if(chiptype == 1)
        readBack = clock_command(ChipType_1_Read_Signature2_Bytes);
    if(chiptype == 2)
        readBack = clock_command(ChipType_2_Read_Signature2_Bytes);


    lastbyte =readBack % 256;
    chipType->chipNameCode = lastbyte;
    log(_T("Chip Name: ")+chipType->getName());




}






/*
readLockBits  last byte (byte 4)



89s51  xxx LB3     LB2 LB1 xx
 (a programmed lock bit reads back as a “1”)




89s52  xxx LB3     LB2 LB1 xx     ??
 (a programmed lock bit reads back as a ‘1’)



89s8253       xxxx  x LB3 LB2  LB1
 (A programmed lock bit reads back as a “0”)

*/


void IspProgrammer::readLockBits( ChipType* chipType)
{

    setupComm();
    prog_enable(0);

    unsigned long readBack = 0;
    readBack = clock_command(Read_LOCK_BITS);


    if(chipType->chipNameCode == ChipType::CHIPTYPE_89S51 || chipType->chipNameCode == ChipType::CHIPTYPE_89S52 )
    {
        int maskByte = readBack >> 2;
        chipType->lockbits = maskByte;
    }


    if(chipType->chipNameCode ==  ChipType::CHIPTYPE_89S8253)
    {
        chipType->lockbits = readBack;
    }


    resetPort();

}



/*


89s51 1010 1100 1110  00 B1 b2  xxxx xxxx xxxx xxxx
B1 = 0, B2 = 0 →  Mode 1, no lock protection
B1 = 0, B2 = 1 →  Mode 2, lock bit 1 activated Mode 3, lock bit 2 activated
B1 = 1, B2 = 0 →  Mode 3, lock bit 2 activated
B1 = 1, B2 = 1 →  Mode 4, lock bit 3 activated


89s51 1010 1100  1110 00 B1 B2 xxxx xxxx xxxx xxxx
B1 = 0, B2 = 0 →  Mode 1, no lock protection
B1 = 0, B2 = 1 →  Mode 2, lock bit 1 activated Mode 3, lock bit 2 activated
B1 = 1, B2 = 0 →  Mode 3, lock bit 2 activated
B1 = 1, B2 = 1 →  Mode 4, lock bit 3 activated



89s8253     1010 1100    1110   0 LB3 LB2 LB1  xxxx xxxx xxxx xxxx
(write a “0” to lock)


*/



void IspProgrammer::writeLockBits(int mode,ChipType* chipType)
{


    unsigned long lockBits  = 0XACE00000;

    prog_enable(0);
    unsigned long readBack = 0;
    if(chipType->chipNameCode == ChipType::CHIPTYPE_89S51 || chipType->chipNameCode == ChipType::CHIPTYPE_89S52 )
    {
        if(mode == 2)
        {
            lockBits  = lockBits | 0x10000;
        }
        if(mode == 3)
        {
            lockBits  = lockBits | 0x20000;
        }
        if(mode == 4)
        {
            lockBits  = lockBits | 0x30000;
            lockBits  = lockBits | 0x20000;
        }


    }
    if(chipType->chipNameCode ==  ChipType::CHIPTYPE_89S8253)
    {

        lockBits  = 0XACE70000;

        if(mode == 2)
        {

            lockBits = lockBits & ~ 0x10000;
        }
        if(mode == 3)
        {
            lockBits = lockBits & ~ 0x10000;
            lockBits = lockBits & ~ 0x20000;
        }
        if(mode == 4)
        {
            lockBits = lockBits & ~ 0x10000;
            lockBits = lockBits & ~ 0x20000;
            lockBits = lockBits & ~ 0x40000;
        }

    }

    readBack = clock_command(lockBits);
    int lastbyte =readBack % 0xff;

    resetPort();




}



unsigned long IspProgrammer::prog_enable(int tClockType )
{

    unsigned long result =sendSerialCommand(_T("p"));
    return result;

}





bool isNumber(char ch)
{

    return (ch >=48  && ch <=57);

}


//karsten

unsigned long IspProgrammer::sendSerialCommand(wxString command,bool reply)
{

    char cSendString[20];
    strcpy(cSendString,(const char*) command.mb_str(wxConvUTF8));
    write(fd, cSendString, strlen(cSendString));



    int timeout = 0;

    if(reply)
    {

        unsigned char buf[50];
        unsigned int res= 0;
        int index=0;
        char result[50];
        bool done = false;



        while(! done)
        {
            res =0;
            while (res == 0 )
            {
                res = read(fd,buf , 1);

                /*
                        timeout++;
                        if(timeout > 1000){
                            res = 1;
                            buf[0] = 'x';
                            log(_T("Timeout"));
                        }
                */

            }
            timeout=0;
            result[index] = buf[0];
            //printf("ch %i\n",buf[0]);
            if( ! isNumber(buf[0])) done = true;
            index++;
        }

        result[index-1] = 0;



        unsigned long  li= atol (result);

        return li;

    }

    return 0;

}





unsigned long IspProgrammer::clock_command(unsigned long command)
{

    wxString commandstring = wxString::Format(wxT("c%luc"),command);
    //printf("c%xc",command);
    unsigned long result = sendSerialCommand(commandstring);
    return result;

}












void IspProgrammer::resetPort()
{
    sendSerialCommand(_T("r"));
    log(_T("Closing Parallel Port and making RESET LOW " ));
}



/*

    char2hexdata

*/


unsigned char char2hexdata(unsigned char upnib,unsigned char lownib)

{
    unsigned char data=0;


    if((upnib>47)&&(upnib<58))
        upnib=upnib-48;
    else
        upnib=(upnib-65)+10;

    if((lownib>47)&&(lownib<58))
        lownib=lownib-48;
    else
        lownib=(lownib-65)+10;

    data|=upnib<<4;
    data|=lownib<<0;

    return data;
}


/*

    char2hexaddr

*/
unsigned int char2hexaddr(unsigned int *addr)
{
    unsigned char i,temp;
    unsigned int address=0,j;
    for(i=0,j=12; i<4; i++)

    {
        temp=0;
        temp=addr[i];
        if((temp>=48)&&(temp<=57))
            temp=temp-48;
        else
            temp=(temp-65)+10;
        address|=((unsigned int)temp<<j);

        j=j-4;
    }
    return address;
}


/*

    ascii2int

*/

unsigned char ascii2int(unsigned char msb,unsigned char lsb)

{
    unsigned char a;

    if((msb>47)&&(msb<58))
        msb=msb-48;
    else
        msb=(msb-65)+10;

    if((lsb>47)&&(lsb<58))
        lsb=lsb-48;
    else
        lsb=(lsb-65)+10;

    lsb=1*lsb;
    msb=16*msb;
    a=lsb+msb;
    return a;
}





void IspProgrammer::programFile(wxString fileName, wxGauge* progressBar)
{

    FILE *bin;
    unsigned long data =0;
    unsigned  long address_flash =0;




    log(_T("********** programFile ****************"));





    wxFileName  fi =  wxFileName(fileName);
    wxULongLong size = fi.GetSize() ;
    int max = size.ToULong();



    wxMutexGuiEnter();
    progressBar->SetRange(max-1);
    repportWindow->Clear();



    wxMutexGuiLeave();

    char cFileName[100];
    strcpy(cFileName,(const char*) fileName.mb_str(wxConvUTF8));



    if((bin=fopen(cFileName,"r"))==NULL)
    {
        wxMutexGuiEnter();
        log(_T("File not found: ")+fileName);
        wxMutexGuiLeave();
        return ;
    }



     chip_erase();
      log(_T("Chip Erased"));

    log(_T("Going to program"));


    int result =sendSerialCommand(_T("p"));
    wxString stringnumber = wxString::Format(wxT("P: %i "),result) ;
    log(stringnumber);


    result =sendSerialCommand(_T("w"));  // set adresscounter to 0

    wxString buf;


    while((data=fgetc(bin))!=EOF and mayRun)
    {
        writeflash(data,address_flash);
        wxString stringnumber = wxString::Format(wxT("%02X ") ,data);

        if(address_flash %10 == 0){
         wxMutexGuiEnter();
         repportWindow->AppendText(buf);
         progressBar->SetValue(address_flash);
         wxMutexGuiLeave();
         buf = _T("");
        }else{
          buf.Append(stringnumber);
        }


        address_flash++;
    }

    wxMutexGuiEnter();
    progressBar->SetValue(0);
    wxMutexGuiLeave();

    fclose(bin);



    result = sendSerialCommand(_T("w"));



    resetPort();

       if(!mayRun){
        wxMutexGuiEnter();
        repportWindow->AppendText(_T("\n\nCanceled"));
        progressBar->SetValue(0);
        wxMutexGuiLeave();
        mayRun = TRUE;

   }



}





unsigned char fgetCh(FILE *hex, wxGauge* progressBar)
{

    wxMutexGuiEnter();
    progressBar->SetValue(progressBar->GetValue()+1);
    wxMutexGuiLeave();
    return fgetc(hex);
}




/*

    readAndConvertFile

*/










long IspProgrammer::readAndConvertFile(wxString fileName, wxGauge* progressBar)
{

    FILE *hex,*bin,*buf;
    unsigned int line=0;
    unsigned char a,d,e,data;
    unsigned char b,c,upnib,lownib;
    unsigned int address,k,addr[4];
    long programSize =0;
    long adressHigh = 0;

    log(_T("********** readAndConvertFile ****************"));

    wxString binFileName = fileName.Left(fileName.length()-4) +_T(".bin") ;


    char cBinFileName[100];
    strcpy(cBinFileName,(const char*) binFileName.mb_str(wxConvUTF8));



    char cFileName[100];
    strcpy(cFileName,(const char*) fileName.mb_str(wxConvUTF8));


    wxULongLong size = fileName.length() ;
    int max = size.ToULong();

    wxMutexGuiEnter();
    progressBar->SetRange(max-1);
    wxMutexGuiLeave();


    wxMutexGuiEnter();
    log(_T("Hex file loaded to convert"));
    log(_T("Hex File ") +fileName);
    log(_T("Bin File ") +binFileName);
    wxMutexGuiLeave();


    if((hex=fopen(cFileName,"r"))==NULL)
    {
        //printf("\nFile not found: %s\n",fileName);
        wxMutexGuiEnter();
        log(_T("File not found: ")+fileName);
        wxMutexGuiLeave();
        return 0;
    }




    if((bin=fopen(cBinFileName,"w"))!=NULL)
    {
        wxMutexGuiEnter();
        log(_T("File opened for write: ")+binFileName);
        wxMutexGuiLeave();

    }
    else
    {

        wxMutexGuiEnter();
        log(_T("File could not be created "));
        wxMutexGuiLeave();

    }




    /////////////////////////////////////////////



    while((k=fgetc(hex))!=EOF)
    {
        if(k==':')   line++;
    }//total no of lines in the hex file

    rewind(hex);
    line=line-1;//skipping the last line to be printed

    ///////////////////


    while(line--)
    {

        while(fgetCh(hex,progressBar)!=':');

        {
            a=fgetCh(hex,progressBar);
            c=fgetCh(hex,progressBar);
            b=ascii2int(a,c);





            for(c=0; c<4; c++)
            {
                addr[c]=fgetCh(hex,progressBar);
            }


            address=char2hexaddr(addr);


            for(c=0; c<2; c++) //skipping the next line information
                fgetCh(hex,progressBar);


            for(c=0; c<b; c++) //1byte of data to be converted to the hexadecimal no
            {
                unsigned  int address_flash;

                upnib=fgetCh(hex,progressBar);
                lownib=fgetCh(hex,progressBar);
                data=char2hexdata(upnib,lownib);
                address_flash=address;
                address_flash+=c;

                if(address_flash > adressHigh)
                {
                    adressHigh = address_flash;
                }
                programSize++;



                fseek ( bin , address_flash , SEEK_SET );
                fputc(data, bin);


            }


            for(e=0; e<2; e++) //skipping the checksum
                a=fgetCh(hex,progressBar);




        }


        address=0;

    }

    fclose(bin);
    fclose(hex);

    wxString stringnumber = wxString::Format(wxT("ProgramSize %ld \nAdressHigh %ld ") ,programSize,adressHigh);
    wxMutexGuiEnter();
    log(stringnumber);
    progressBar->SetValue(0);
    wxMutexGuiLeave();


    //printf("\nprogramSize %ld",programSize);
    //printf("\nadressHigh %ld\n",adressHigh);

    return programSize;



}




void IspProgrammer::setInterface( int interfaceToSet)
{

    interface = interfaceToSet;

}

void IspProgrammer::setComDevice( wxString comDeviceToSet)
{

    comDevice =  _T("/dev/")+comDeviceToSet;

}


void IspProgrammer::setSerialDescripter(int fdToSset)
{
    fd = fdToSset;

}





void IspProgrammer::log( wxString logline,bool clear )
{


    wxString fileName = _T("log.txt");

    wxDateTime datetime = wxDateTime::Today();
    wxString dateString = datetime.Format(_T("%d-%m-%Y %H:%M:%S"));

//logline = dateString + _T(" >>> ") +logline;

    wxTextFile file(fileName);
    wxMBConv& conv = wxConvISO8859_1;
    wxTextFileType typeNew = wxTextFileType_Dos;

    if(! file.Exists())
    {
        file.Create();
    }

    file.Open( conv);
    if(clear)
    {
        file.Clear();
    }

    file.AddLine(logline);
    file.Write(typeNew,conv);
    file.Close();


}














void IspProgrammer::showFile(wxString fileName){

 FILE *bin;
    unsigned int data;
    unsigned  int address_flash =0;



    wxFileName  fi =  wxFileName(fileName);
    wxULongLong size = fi.GetSize() ;
    int max = size.ToULong();


    char cFileName[100];
    strcpy(cFileName,(const char*) fileName.mb_str(wxConvUTF8));





    if((bin=fopen(cFileName,"r"))==NULL)
    {

        log(_T("File not found: ")+fileName);

        return ;
    }


wxMutexGuiEnter();
    wxDialog   textDialog(NULL , -1, _T("Dialog"),  wxDefaultPosition,  wxSize( 600, 500 ));
    wxTextCtrl* textWindow = new wxTextCtrl(&textDialog  , -1, _T(""), wxDefaultPosition ,wxSize( 600, 500 ),wxTE_MULTILINE);
wxMutexGuiLeave();



    int line =0;


     wxMutexGuiEnter();
    textWindow->AppendText(_T("\n0x00  :"));;
    wxMutexGuiLeave();






    while((data=fgetc(bin))!=EOF and mayRun)
    {
        wxString stringnumber = wxString::Format(wxT("%2x  ") ,data);
        textWindow->AppendText(stringnumber);
        address_flash++;
        line++;
        if(line >= 10)
        {
            line =0;
            wxString stringnumber = wxString::Format(wxT("\n0x%2x  : ") ,address_flash);


     wxMutexGuiEnter();
    textWindow->AppendText(stringnumber);;
    wxMutexGuiLeave();




        }

    }


    //textDialog.ShowModal();



    if(!mayRun){
        wxMutexGuiEnter();
        repportWindow->AppendText(_T("\n\nCanceled"));
//        progressBar->SetValue(0);
        wxMutexGuiLeave();
        mayRun = TRUE;

   }



        wxMutexGuiEnter();
        textDialog.Show();
        wxMutexGuiLeave();

}








void IspProgrammer::setRepportWindow(wxTextCtrl* repportWindow){

 this->repportWindow = repportWindow;

}






void IspProgrammer::setJobEnable(bool enable){
  mayRun = enable;

/*
    if(enable){
      wxMutexGuiEnter();
      statusText->SetLabel(_T("Canceled"));
      progressBar->SetValue(0);
      wxMutexGuiLeave();
  }
*/


}



void IspProgrammer::test()
{

    int readBack =0;
    int lastbyte  =0;
    int result =0;

    wxString stringnumber;


    result =prog_enable(1);
    stringnumber = wxString::Format(wxT("prog_enable: %x\n") ,result);
    log(stringnumber);


    readBack = clock_command(ChipType_2_Read_Signature1_Bytes);
    lastbyte =readBack % 256;
    stringnumber = wxString::Format(wxT("Signatur   : %x") ,lastbyte);

    log(stringnumber);






    return;

    ChipType  chipType;
    chipType.Init();
    chipType.type =1;


    readBack = clock_command(ChipType_1_Read_Signature1_Bytes);
    lastbyte =readBack % 256;
    printf("\nSignatur 1  : %x\n", lastbyte );
    chipType.manufactureCode  = lastbyte;
    log(_T("Chip Manufactured: ")+chipType.getManufactured());


    readBack = clock_command(ChipType_1_Read_Signature2_Bytes);
    lastbyte =readBack % 256;
    printf("\nSignatur 2 : %x\n", lastbyte );
    chipType.chipNameCode = lastbyte;
    log(_T("Chip Name: ")+chipType.getName());


    readBack = clock_command( Read_LOCK_BITS);
    printf("\nLock bits : %x\n", lastbyte );
    chipType.lockbits = lastbyte;
    log(_T("LockMode: ")+chipType.getLockMode());


}


