#ifndef ISP_ROGRAMMER_H
#define ISP_ROGRAMMER_H

#include <wx/string.h>
#include <wx/wfstream.h>
#include "wx/process.h"
#include <wx/combobox.h>
#include <wx/tokenzr.h>

#include "wx/msgdlg.h"
#include "IspThread.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <wx/progdlg.h>
#include<sys/io.h>
#include "ChipType.h"
#include <wx/gauge.h>
#include <wx/filename.h>
#include <wx/stattext.h>
#include <wx/textfile.h>
#include <wx/msgdlg.h>

#include <wx/textdlg.h>
#include <wx/msgdlg.h>
#include <wx/stopwatch.h>






class IspProgrammer
{

public:

    /*
    //Arduino commands
     wxString  MOSI_SET ;
     wxString  MOSI_CLEAR ;
     wxString  SCK_SET;
     wxString  SCK_CLEAR;
     wxString  RESET_SET ;
     wxString  RESET_CLEAR;
     wxString  ASK_FOR_DATA;
    */


    //IspThread*  serialReaderThread ;

    int fd;
    int interface;
    wxString  comDevice;
    wxTextCtrl* repportWindow;

    wxString  getUSBPorts(wxComboBox* comboBoxInterface,wxString filter);
    wxString  doShellCommand(wxString command);
    wxString  readStream(wxInputStream *input);
    wxString  readFlash(wxProgressDialog *progress);

    IspProgrammer();


    unsigned long clock_command (unsigned long command);
    unsigned long clock_command_1 (unsigned long command);
    unsigned long clock_usb_command_1 (unsigned long command);
    unsigned long clock_usb_command_2 (unsigned long command);
    unsigned long clock_command_2 (unsigned long command);
    //unsigned long clock_usb_command_2 (unsigned long command);

    int pport_enable( wxStaticText* statusText,wxComboBox* comboBoxPort) ;
    void detectChipType( ChipType* chipType);
    void readLockBits( ChipType* chipType);
    wxString verifyFlash(wxString fileName, wxGauge* progressBar);
    void writeLockBits(int mode,ChipType* chipType);

    void resetPort();
    unsigned long prog_enable(int clockType );
    void getChipDescription();
    long readAndConvertFile(wxString, wxGauge* progressBar);
    void programFile(wxString fileName, wxGauge* progressBar);

    void writeflash(unsigned long data,unsigned long address);
    int setupComm();
    void chip_erase(void);
    wxString  dumpFlash(wxString fileName ,wxGauge *progress);
    void log( wxString logline,bool clear=FALSE );

    unsigned long sendSerialCommand(wxString command,bool reply =true);
    unsigned long sendSerialCommand(int command);
    unsigned char getSpiDataBySerial();
    void setupSerialReader();
    void pportWrite(int set);
    void setInterface( int interface);
    void setComDevice( wxString comDeviceToSet);
    void setSerialDescripter(int fd);
    void setRepportWindow(wxTextCtrl* repportWindow);

    void showFile(wxString fileName);
    void setJobEnable(bool enable);



    void test();




};
#endif
