#include "IspThread.h"



IspProgrammer ipp;

IspThread::IspThread()
{

}



IspThread::~IspThread()
{
}



void* IspThread::Entry()
{




    if(threadJob == threadJob_Verify)
    {

        wxMutexGuiEnter();
        statusText->SetLabel(_T("Verifying"));
        wxMutexGuiLeave();



        ipp.setComDevice(comDevice);
        ipp.setSerialDescripter(fd);
        wxString result =ipp.verifyFlash(LoadedFileName,progressBar);

        wxMutexGuiEnter();
        statusText->SetLabel(result);
        wxMutexGuiLeave();
    }

    if(threadJob == threadJob_Dump)
    {

        wxMutexGuiEnter();
        statusText->SetLabel(_T("Dumping"));
        wxMutexGuiLeave();



        ipp.setComDevice(comDevice);
        ipp.setSerialDescripter(fd);

        ipp.setRepportWindow(repportWindow);


        wxString result = ipp.dumpFlash(LoadedFileName ,progressBar);

        wxMutexGuiEnter();
        statusText->SetLabel(result);
        wxMutexGuiLeave();
    }








    if(threadJob == threadJob_Program)
    {


        /*
         wxMutexGuiEnter();
          statusText->SetLabel(_T("Converting file"));
          wxMutexGuiLeave();



          IspProgrammer ipp ;
          int result = ipp.readAndConvertFile( LoadedFileName, repportWindow,progressBar);

        */


        ipp.setInterface(interface);

        wxMutexGuiEnter();
        statusText->SetLabel(_T("Programming"));
        progressBar->SetValue(0);
        wxMutexGuiLeave();

        ipp.setComDevice(comDevice);
        ipp.setSerialDescripter(fd);
        ipp.setRepportWindow(repportWindow);
        ipp.programFile(LoadedFileName, progressBar);




        wxMutexGuiEnter();
        statusText->SetLabel(_T("OK"));
        wxMutexGuiLeave();


    }


    if(threadJob == threadJob_ProgramFromBin)
    {



        wxMutexGuiEnter();
        statusText->SetLabel(_T("Programming"));
        progressBar->SetValue(0);
        wxMutexGuiLeave();



        ipp.setComDevice(comDevice);
        ipp.setSerialDescripter(fd);
        ipp.programFile(LoadedFileName, progressBar);




        wxMutexGuiEnter();
        statusText->SetLabel(_T("OK"));
        wxMutexGuiLeave();


    }


    if(threadJob == threadJob_LoadFile)
    {



        wxMutexGuiEnter();
        statusText->SetLabel(_T("Loading"));
        progressBar->SetValue(0);
        wxMutexGuiLeave();



        int result = ipp.readAndConvertFile( LoadedFileName , progressBar);




        wxMutexGuiEnter();
        statusText->SetLabel(_T("OK"));
        wxMutexGuiLeave();


    }




    if(threadJob == threadJob_Test)
    {

        wxMutexGuiEnter();
        statusText->SetLabel(_T("Programming Bin"));
        wxMutexGuiLeave();


        char * fileName = "bin";

        //ipp.programFile( fileName, repportWindow,progressBar);

        /*
        wxMutexGuiEnter();
        statusText->SetLabel(result);
        wxMutexGuiLeave();
        */

    }



    if(threadJob == threadJob_SerialRead)
    {


        wxString outBuf ;

        ipp.setComDevice(comDevice);
        ipp.setSerialDescripter(fd);
        while(mayRun)
        {
            char buf[255];
            long res = read(fd,buf,255);
            buf[res+1] = 0;
            for(long n=0; n < res; n++)
            {
                char ch = buf[n];
                //printf("%i ",ch);
                if(ch != 13 && ch != 10)
                    outBuf.Append( ch);
                if(ch == 13 )
                {
                    outBuf.Trim(false);
                    outBuf.Trim(true);
                    ipp.log(outBuf);
                    outBuf.Clear();
                }
            }

        }

    }




    return 0;
}



void IspThread::setJob(int job)
{
    threadJob = job;

}

void IspThread::stop()
{
    mayRun = false;

}

/*
void IspThread::setLogWindow(wxTextCtrl* llog){
    this->logWindow = llog;

}


*/


void IspThread::setProcessBar(wxGauge* progressBar)
{

    this->progressBar = progressBar;
}


void IspThread::setStatusText(wxStaticText* statusText)
{

    this->statusText = statusText;

}

void IspThread::setFileName(wxString fileName)
{

    this->LoadedFileName = fileName;

}

void IspThread::setSerialDescripter(int fd)
{

    this->fd = fd;

}

void IspThread::setInterface(int interface)
{
    this->interface = interface;
}
void IspThread::setComDevice( wxString comDeviceToSet)
{

    comDevice =  comDeviceToSet;

}

void IspThread::setRepportWindow( wxTextCtrl* log)
{

    repportWindow = log;

}



void IspThread::setJobEnable(bool enable){
  ipp.setJobEnable(enable);

}






