#ifndef MYTHREAD_H
#define MYTHREAD_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <ctype.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/soundcard.h>
#include <wx/textctrl.h>
#include <wx/stattext.h>

#include <wx/dcclient.h>
#include <wx/datetime.h>
#include <wx/gauge.h>
#include "IspProgrammer.h"





class IspThread  : public  wxThread
{

public:

    static const int threadJob_Verify = 1;
    static const int threadJob_Program = 2;
    static const int threadJob_ProgramFromBin = 3;
    static const int threadJob_Dump = 4;
    static const int threadJob_LoadFile = 5;
    static const int threadJob_Test = 6;
    static const int threadJob_SerialRead = 7;



    int threadJob;
    bool mayRun;



    wxTextCtrl*    repportWindow;
    wxGauge* progressBar ;
    wxStaticText* statusText;



    wxString LoadedFileName;
    int fd ;
    int interface;
    wxString  comDevice;



    IspThread();
    virtual  ~IspThread();
    virtual void *Entry();
    void setLogWindow(wxTextCtrl* log);
    void setRepportWindow(wxTextCtrl* log);
    void setProcessBar(wxGauge* processBar);
    void setStatusText(wxStaticText* statusText);
    void setFileName(wxString fileName);
    void setSerialDescripter(int fd);
    void setInterface(int interface);
    void setComDevice( wxString comDeviceToSet);



    void setJob(int job);
    void stop();

    void log(int number);
    void log(wxString number);
    void log(wxString  text, int number);
    void log(float number);
    void logClear();
    void setJobEnable(bool enable);



};

#endif
